% Simuloidaan tehtvn 5 tuotantolaitos-varasto-markkinat systeemi

% Kiinnitetn simulointiaika
T = 100;
% parametri alpha
alpha = 0.5;

% varataan simulaatiossa tarvittaville vektoreille tila etukteen
% varastosaldo
x1 = zeros(T, 1);
%tuotanto
x2 = zeros(T, 1);
%kysynt
u = zeros(T, 1);
%ulostulo
y = zeros(T, 1);

% varaston tavoitetaso
x0 = 90;
% keskimrinen kysynt
v0 = 30;

 
% simualation alkuarvot:
x1(1) = x0; % varastosaldo alussa = tavoitetaso 
x2(1) = v0; % tuotannosta tulee ensimmisell kierroksella keskim. kysynt
u(1) = v0; % kysynt on alussa keskimrinen kysynt
y(1) = x1(1);

%Simulointisilmukka
for t = 2:T
    
   % poista kommentit jostakin allaolevista riveist kokeillaksesi    
   % erilaisia kysyntj (tai keksi oma!). Kommentoi vakiokysynt kuvaava
   % rivi jos kokeilet erilaista kysynt.
   
   % 1) vakiokysynt
   u(t) = u(t - 1);

   % 2) askelmainen kysynnn kasvu:
%    if (t >= T/2)
%        u(t) = 1.5*v0;
%    else
%        u(t) = v0;
%    end

   % 3) kysynnss valkoista kohinaa:
   % kohinan varianssi
%    lambda = 1;
%    if (t >= T/2)
%        u(t) = v0 + sqrt(lambda)*randn(1);
%    else
%        u(t) = v0;
%    end

   % 4) kysynnss valkoista kohinaa + askel:
%    if (t >= T/2)
%        u(t) = 1.5*v0 + sqrt(lambda)*randn(1);
%    else
%        u(t) = v0;
%    end

   % 5) yksittinen poikkeama
%    if (t == 2)
%        u(t) = 1.5*v0;
%    else
%        u(t) = v0;
%    end

   % differenssiyhtl
   x1(t) = x1(t - 1) + x2(t - 1) - u(t - 1);
   x2(t) = (alpha - 1)*x1(t - 1) + alpha*x2(t - 1) + (1 - alpha)*(x0 + v0);
   y(t) = x1(t);
   
end

% varastosaldon kuvaaja
subplot(2,1,1)
stairs(1:T,y,'-r','LineWidth',2);
hold on
% listn kuvaajaan varaston tavoitetaso katkoviivalla
plot(1:T,ones(1,T).*x0,'--k','LineWidth',2);
title('Varastosaldo','FontSize',16);

% kysynnn kuvaaja
subplot(2,1,2)
stairs(1:T,u(1:T),'-b','LineWidth',2);
u_interval=max(u)-min(u);
if(u_interval>0)
    axis([0 T min(u)-0.1*u_interval max(u)+0.1*u_interval])
end
hold on
% listn kuvaajaan keskimrinen kysynt katkoviivalla
plot(1:T,ones(1,T).*v0,'--k','LineWidth',2);
title('Kysynt','FontSize',16)